#ifndef TEMP_SPARSE_MATRIX_H_
#define TEMP_SPARSE_MATRIX_H_

#include "lis.h"

/* Quick and dirty matrix to help construct the final sparse matrix */
/* Will crash if arguments are not valid */

typedef struct tmp_matrix_str {
    int nrows, maxcols, nnz, row_size;
    double *val;
    int *col_num;
} *TmpMatrix;

TmpMatrix  CreateTempSparseMatrix (int nrows, int maxcols);
void       DestroyTempSparseMatrix (TmpMatrix *A);
int        SetMatrixValue (TmpMatrix A, int i, int j, double value);
int        AddMatrixValue (TmpMatrix A, int i, int j, double value);
int        CopyNewMatrixValue (TmpMatrix A, int src_i, int src_j,
                            int dest_i, int dest_j, double *value);
LIS_MATRIX GetLisMatrix (TmpMatrix A);

#endif
